#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <libgen.h>

int main( int argc, char **argv ) {
  int fd, fd2, i, j;
  
  if ( argc < 4 || strcmp( argv[2], "--section" ) ) {
  	printf( "usage: %s filename.vxd --section <name>\n",
		basename( argv[0] ) );
	return 1;
  }
  
  fd = open( argv[1], O_RDONLY );
  if ( fd == -1 ) {
  	perror( "open" );
	return 1;
  }

  int hdr_offs, secnum, idxptr, pgnum, dataoffs, pgsize;
  char hdr[0xb0], sechdr[0x18], *pgtbl, *buf;
  
  lseek( fd, 0x3c, SEEK_SET );
  read( fd, &hdr_offs, 4 );
  lseek( fd, hdr_offs, SEEK_SET );
  read( fd, hdr, sizeof(hdr) );
  lseek( fd, hdr_offs + *(unsigned long*)&hdr[0x40], SEEK_SET );
  secnum = *(unsigned long*)&hdr[0x44];
  for ( i = 0; i < secnum; i++ ) {
  	read( fd, sechdr, sizeof(sechdr) );
	if ( !strncasecmp( &sechdr[0x14], argv[3], 4 ) ) {
		idxptr = hdr_offs + *(unsigned long*)&hdr[0x48] +
			(*(unsigned long*)&sechdr[0x0c] - 1) * 4;
		pgnum = *(unsigned long*)&sechdr[0x10];
		lseek( fd, idxptr, SEEK_SET );
		pgtbl = (char*) malloc( pgnum * 4 );
		read( fd, pgtbl, pgnum * 4 );
		dataoffs = *(unsigned long*)&hdr[0x80];
		pgsize = *(unsigned long*)&hdr[0x28];
		buf = (char*) malloc( pgsize );
		fd2 = creat( argv[3], 0644 );
		for ( j = 0; j < pgnum; j++ ) {
			lseek( fd, dataoffs +
				(*(unsigned short*)&pgtbl[j * 4] +
				*(unsigned char*)&pgtbl[j * 4 + 2] - 1) *
				pgsize, SEEK_SET );
			read( fd, buf, pgsize );
			write( fd2, buf, pgsize );
		}
		close( fd2 );
		break;
	}
  }
  
  close( fd );
}
