#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <sys/ioctl.h>

// /usr/src/linux/include/scsi/sg.h
#include "sg.h"

int main() {
  int fd, rc, i, j;
  sg_io_hdr sg;
//  unsigned char buf[] = "\x28\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00";
  unsigned char buf[] = "\x5a\x08\x01\x00\x00\x00\x00\x00\x20\x00\x00\x00";
//  unsigned char buf[] = "\x12\x00\x00\x00\x96\x00";
  unsigned char repbuf[0x800];
  unsigned char sense[0xe];
  
  fd = open( "/dev/sg0", O_RDWR );
  if ( fd == -1 ) {
  	perror( "open sg0" );
	return 1;
  }
 
  memset( &sg, 0, sizeof(sg) );
  sg.interface_id = 'S';
  sg.dxfer_direction = SG_DXFER_FROM_DEV;
  sg.cmd_len = 0xc;
//  sg.cmd_len = 6;
  sg.mx_sb_len = 0xe;
  sg.iovec_count = 0;
  sg.dxfer_len = 0x20;
  sg.dxferp = repbuf;
  sg.cmdp = buf;
  sg.sbp = sense;
  sg.timeout = 0x1c00;
  
  rc = ioctl( fd, SG_IO, &sg );
  if ( rc == -1 ) {
  	perror( "write" );
	return 1;
  }
  close( fd );
  
  if ( (sg.info & SG_INFO_OK_MASK) == SG_INFO_OK ) {
  	char c;

  	printf( "scsi reply:\n" );
//	printf( "%8.8s %16.16s %4.4s\n", repbuf + 8, repbuf + 16, repbuf + 32 );
#if 1
	for ( i = 0; i*16 < sg.dxfer_len; i++ ) {
		printf( "%04X: ", i * 16 );
		for ( j = 0; j < 16 && i*16 + j < sg.dxfer_len; j++ )
			printf( " %02X",  repbuf[i * 16 + j] );
		printf( "   " );
		for ( j = 0; j < 16 && i*16 + j < sg.dxfer_len; j++ ) {
			c = repbuf[i * 16 + j];
			putchar( (c >= 32 && c != 127)? c: '.' );
		}
		putchar( '\n' );
	}
#endif
  }
  
  if ( sg.sb_len_wr > 0 ) {
  	printf( "sense data:" );
	for ( i = 0; i < sg.sb_len_wr; i++ ) printf( " %02X",  sg.sbp[i] );
	putchar( '\n' );
  }

  puts( "successful" );
}
