			.text
			
			.globl call_ctl_disp
	call_ctl_disp:
			push	%ebp
			mov	%esp, %ebp
			mov	12(%ebp), %eax
			call	*8(%ebp)
			pop	%ebp
			ret

			.globl VMM_ListCreate
	VMM_ListCreate:
			pushl	%ebp
			movl	%esp, %ebp
			sub	$4, %esp
			pusha
			pushl	%ecx
			pushl	%eax
			call	__VMM_ListCreate
			addl	$8, %esp
			movl	%eax, -4(%ebp)
			popa
			popl	%esi
			clc
			orl	%esi, %esi
			jnz	VMM_ListCreate_ok
			stc
	VMM_ListCreate_ok:
			popl	%ebp
			ret

			.globl VMM_ListDestroy
	VMM_ListDestroy:
			pusha
			pushl	%esi
			call	__VMM_ListDestroy
			addl	$4, %esp
			popa
			ret

			.globl VMM_List_Get_First
	VMM_List_Get_First:
			pushl	%ebp
			movl	%esp, %ebp
			pushl	%eax
			pusha
			pushl	%esi
			call	__VMM_List_Get_First
			add	$4, %esp
			mov	%eax, -4(%ebp)
			popa
			popl	%eax
			pop	%ebp
			orl	%eax, %eax
			ret

			.globl VMM_List_Get_Next
	VMM_List_Get_Next:
			pushl	%ebp
			movl	%esp, %ebp
			pushl	%eax
			pusha
			pushl	%eax
			pushl	%esi
			call	__VMM_List_Get_Next
			add	$8, %esp
			mov	%eax, -4(%ebp)
			popa
			popl	%eax
			pop	%ebp
			orl	%eax, %eax
			ret

			.globl VMM_ListAllocate
	VMM_ListAllocate:
			pushl	%ebp
			movl	%esp, %ebp
			pushl	%eax
			pusha
			pushl	%esi
			call	__VMM_ListAllocate
			add	$4, %esp
			mov	%eax, -4(%ebp)
			popa
			popl	%eax
			popl	%ebp
			orl	%eax, %eax
			clc
			jnz	VMM_ListAllocate_ok
			stc
	VMM_ListAllocate_ok:
			ret
	
			.globl	VMM_ListDeallocate
	VMM_ListDeallocate:
			pushal
			pushl	%eax
			pushl	%esi
			call	__VMM_ListDeallocate
			add	$0x08, %esp
			popal
			ret

			.globl VMM_List_Remove
	VMM_List_Remove:
			pusha
			pushl	%eax
			pushl	%esi
			call	__VMM_List_Remove
			add	$8, %esp
			orl	%eax, %eax
			clc
			jnz	VMM_List_Remove_ok
			stc
	VMM_List_Remove_ok:
			popa
			ret

			.globl VMM_List_Attach
	VMM_List_Attach:
			pusha
			pushl	%eax
			pushl	%esi
			call	__VMM_List_Attach
			add	$8, %esp
			popa
			ret

			.globl VMM_PageGetAllocInfo
	VMM_PageGetAllocInfo:
			pushl	%ebp
			movl	%esp, %ebp
			subl	$4, %esp
			pusha
			mov	12(%ebp), %eax
			mov	8(%ebp), %ebx
			push	%eax
			push	%ebx
			call	__VMM_PageGetAllocInfo
			add	$8, %esp
			movl	%eax, -4(%ebp)
			popa
			popl	%edx
			popl	%ebp
			ret

			.globl VMM_PageAllocate
	VMM_PageAllocate:
			pushl	%ebp
			movl	%esp, %ebp
			subl	$4, %esp
			pusha
			movl	36(%ebp), %ecx
			movl	32(%ebp), %edx
			pushl	%ecx
			pushl	%edx
			mov	28(%ebp), %eax
			mov	24(%ebp), %ebx
			mov	20(%ebp), %ecx
			mov	16(%ebp), %edx
			pushl	%eax
			pushl	%ebx
			pushl	%ecx
			pushl	%edx
			mov	12(%ebp), %eax
			mov	 8(%ebp), %ebx
			pushl	%eax
			pushl	%ebx
			call	__VMM_PageAllocate
			add	$0x20, %esp
			movl	%eax, -4(%ebp)
			popa
			popl	%eax
			popl	%ebp
			ret

			.globl VMM_Hook_Device_Service
	VMM_Hook_Device_Service:
			pushl	%ebp
			movl	%esp, %ebp
			pushl	%eax
			pusha
			pushl	%esi
			pushl	%eax
			call	__VMM_Hook_Device_Service
			add	$8, %esp
			mov	%eax, -4(%ebp)
			popa
			popl	%eax
			orl	%eax, %eax
			clc
			jnz	VMM_Hook_Device_Service_ok
			stc
	VMM_Hook_Device_Service_ok:
			popl	%ebp
			ret

			.globl	VMM_lstrlen
	VMM_lstrlen:
			mov	4(%esp), %eax
			pushl	%eax
			call	__VMM_lstrlen
			popl	%edx
			add	%eax, %edx
			ret

			.globl	IOS_SendCommand
	IOS_SendCommand:
			pusha
			pushl	%edi
			pushl	%esi
			call	__IOS_SendCommand
			add	$0x08, %esp
			popa
			ret

			.globl	ILB_service_rtn
	ILB_service_rtn:
			pushl	%ebp
			movl	%esp, %ebp
			pushal
			pushl	0x08(%ebp)
			call	__ILB_service_rtn
			add	$0x04, %esp
			popal
			popl	%ebp
			ret

			.globl	ILB_dprintf_rtn
	ILB_dprintf_rtn:
			pushal
			call	__ILB_dprintf_rtn
			popal
			ret

			.globl	ILB_wait_10th_sec
	ILB_wait_10th_sec:
			pushal
			call	__ILB_wait_10th_sec
			popal
			ret

			.globl	ILB_internal_request
	ILB_internal_request:
			pushal
			pushl	%edx
			pushl	%ebx
			pushl	%edi
			call	__ILB_internal_request
			add	$0x0c, %esp
			popal
			ret
	
			.globl	ILB_io_criteria_rtn
	ILB_io_criteria_rtn:
			pushl	%ebp
			movl	%esp, %ebp
			pushal
			pushl	0x08(%ebp)
			call	__ILB_io_criteria_rtn
			add	$0x04, %esp
			popal
			popl	%ebp
			xor	%eax, %eax
			ret
	
			.globl	ILB_int_io_criteria_rtn
	ILB_int_io_criteria_rtn:
			pushl	%ebp
			movl	%esp, %ebp
			pushal
			pushl	0x08(%ebp)
			call	__ILB_int_io_criteria_rtn
			add	$0x04, %esp
			popal
			popl	%ebp
			xor	%eax, %eax
			ret
	
			.globl	ILB_enqueue_iop
	ILB_enqueue_iop:
			pushal
			call	__ILB_enqueue_iop
			popal
			ret

			.globl	ILB_dequeue_iop
	ILB_dequeue_iop:
			pushal
			call	__ILB_dequeue_iop
			popal
			ret
