#include <list>
using namespace std;

struct IOP;
struct IOR;
struct DCB;

extern "C" {
void call_ctl_disp( void (*)(int), int msg );
list <char*> *VMM_ListCreate( int flags, int nodesize );
void VMM_ListDestroy( list <char*> *lst );
char *VMM_List_Get_First( list <char*> *lst );
char *VMM_List_Get_Next( list <char*> *lst, char *node );
char *VMM_ListAllocate( list <char*> *lst );
void VMM_ListDeallocate( list <char*> *lst, char *node );
bool VMM_List_Remove( list <char*> *lst, char *node );
void VMM_List_Attach( list <char*> *lst, char *node );
int VMM_PageGetAllocInfo( int flags );
int VMM_PageAllocate( int nPages, int pType, int hVM, int AlignMask,
	int minPhys, int maxPhys, int *PhysAddr, int Flags );
int VMM_Hook_Device_Service( int service, int hook );
int VMM_lstrlen( char *s );
void IOS_SendCommand( IOR *ior, DCB *dcb );
list <char*> *__VMM_ListCreate( int flags, int nodesize );
void __VMM_ListDestroy( list <char*> *lst );
char *__VMM_List_Get_First( list <char*> *lst );
char *__VMM_List_Get_Next( list <char*> *lst, char *node );
char *__VMM_ListAllocate( list <char*> *lst );
void __VMM_ListDeallocate( list <char*> *lst, char *node );
bool __VMM_List_Remove( list <char*> *lst, char *node );
void __VMM_List_Attach( list <char*> *lst, char *node );
int __VMM_PageGetAllocInfo( int flags );
int __VMM_PageAllocate( int nPages, int pType, int hVM, int AlignMask,
	int minPhys, int maxPhys, int *PhysAddr, int Flags );
int __VMM_Hook_Device_Service( int service, int hook );
int __VMM_lstrlen( char *s );
void __IOS_SendCommand( IOR *ior, DCB *dcb );
//void ILB_internal_request( IOP *iop, DCB *dcb, void (*)(IOP*) );
}

#pragma pack(1)

struct VRP;

struct DCB_cd_entry {
  void (*DCB_cd_io_address)(IOP*);			/* 00 */
  unsigned int DCB_cd_flags;				/* 04 */
  void *DCB_cd_ddb;					/* 08 */
  struct DCB_cd_entry *DCB_cd_next;			/* 0c */
  short DCB_cd_expan_off;				/* 10 */
  unsigned char DCB_cd_layer_flags;			/* 12 */
  unsigned char DCB_cd_lgn;				/* 13 */
							/* 14 */
};

struct DCB_COMMON {
  unsigned long DCB_physical_dcb;			/* 00 */
  unsigned long DCB_expansion_length;			/* 04 */
  DCB_cd_entry *DCB_ptr_cd;				/* 08 */
  DCB_COMMON *DCB_next_dcb, *DCB_next_logical_dcb;	/* 0c */
  char DCB_drive_lttr_equiv;				/* 14 */
  char DCB_unit_number;					/* 15 */
  unsigned short DCB_TSD_flags;				/* 16 */
  VRP *DCB_vrp_ptr;					/* 18 */
  unsigned long DCB_dmd_flags;				/* 1c */
  unsigned long DCB_device_flags;			/* 20 */
  unsigned long DCB_device_flags2;			/* 24 */
  unsigned long DCB_Partition_Start;			/* 28 */
  unsigned long DCB_track_table_ptr;			/* 2c */
  unsigned long DCB_bds_ptr;				/* 30 */
  unsigned long DCB_Reserved1;				/* 34 */
  unsigned long DCB_Reserved2;				/* 38 */
  char DCB_apparent_blk_shift;				/* 3c */
  char DCB_partition_type;				/* 3d */
  unsigned short DCB_sig;				/* 3e */
  char DCB_device_type;					/* 40 */
  unsigned long DCB_Exclusive_VM;			/* 41 */
  unsigned char DCB_disk_bpb_flags;			/* 45 */
  unsigned char DCB_cAssoc;				/* 46 */
  unsigned char DCB_Sstor_Host;				/* 47 */
  unsigned short DCB_user_drvlet;			/* 48 */
  unsigned short DCB_Reserved3;				/* 4a */
  unsigned long DCB_Reserved4;				/* 4c */
  							/* 50 */
};

struct DCB_BLOCKDEV {
  unsigned long DCB_BDD_Next;				/* 00 c3 */
  char DCB_BDD_BD_Major_Version;			/* 04 c7 */
  char DCB_BDD_BD_Minor_Version;			/* 05 c8 */
  char DCB_BDD_Device_SubType;				/* 06 c9 */
  char DCB_BDD_Int_13h_Number;				/* 07 ca */
  unsigned long DCB_BDD_flags;				/* 08 cb */
  unsigned long DCB_BDD_Name_Ptr;			/* 0c cf */
  unsigned long DCB_apparent_sector_cnt[2];		/* 10 d3 */
  unsigned long DCB_apparent_blk_size;			/* 18 db */
  unsigned long DCB_apparent_head_cnt;			/* 1c df */
  unsigned long DCB_apparent_cyl_cnt;			/* 20 e3 */
  unsigned long DCB_apparent_spt;			/* 24 e7 */
  unsigned long DCB_BDD_Sync_Cmd_Proc;			/* 28 eb */
  unsigned long DCB_BDD_Command_Proc;			/* 2c ef */
  unsigned long DCB_BDD_Hw_Int_Proc;			/* 30 f3 */
  unsigned long DCB_BDP_Cmd_Queue_Ascending;		/* 34 f7 */
  unsigned long DCB_BDP_Cmd_Queue_Descending;		/* 38 fb */
  unsigned long DCB_BDP_Current_Flags;			/* 3c ff */
  unsigned long DCB_BDP_Int13_Param_Ptr;		/* 40 103 */
  unsigned long DCB_BDP_Current_Command;		/* 44 107 */
  unsigned long DCB_BDP_Current_Position[2];		/* 48 10b */
  unsigned long DCB_BDP_Reserved[5];			/* 50 113 */
  unsigned long DCB_fastdisk_bdd;			/* 64 127 */
  							/* 68 12b */
};

struct DCB {
  DCB_COMMON DCB_cmn;					/* 00 */
  unsigned long DCB_max_xfer_len;			/* 50 */
  unsigned long DCB_actual_sector_cnt[2];		/* 54 */
  unsigned long DCB_actual_blk_size;			/* 5c */
  unsigned long DCB_actual_head_cnt;			/* 60 */
  unsigned long DCB_actual_cyl_cnt;			/* 64 */
  unsigned long DCB_actual_spt;				/* 68 */
  void *DCB_next_ddb_dcb;				/* 6c */
  void *DCB_dev_node;					/* 70 */
  char DCB_bus_type;					/* 74 */
  char DCB_bus_number;					/* 75 */
  unsigned char DCB_queue_freeze;			/* 76 */
  unsigned char DCB_max_sg_elements;			/* 77 */
  unsigned char DCB_io_pend_count;			/* 78 */
  unsigned char DCB_lock_count;				/* 79 */
  unsigned short DCB_SCSI_VSD_FLAGS;			/* 7a */
  char DCB_scsi_target_id;				/* 7c */
  char DCB_scsi_lun;					/* 7d */
  char DCB_scsi_hba;					/* 7e */
  char DCB_max_sense_data_len;				/* 7f */
  unsigned short DCB_srb_ext_size;			/* 80 */
  char DCB_inquiry_flags[8];				/* 82 */
  char DCB_vendor_id[8];				/* 8a */
  char DCB_product_id[16];				/* 92 */
  char DCB_rev_level[4];				/* a2 */
  char DCB_port_name[8];				/* a6 */
  unsigned char DCB_current_unit;			/* ae */
  unsigned long DCB_blocked_iop;			/* af */
  unsigned long DCB_vol_unlock_timer;			/* b3 */
  unsigned char DCB_access_timer;			/* b7 */
  unsigned char DCB_Vol_Flags;				/* b8 */
  char DCB_q_algo;					/* b9 */
  char DCB_unit_on_ctl;					/* ba */
  unsigned long DCB_Port_Specific;			/* bb */
  unsigned long DCB_spindown_timer;			/* bf */
  DCB_BLOCKDEV DCB_bdd;					/* c3 */
  							/* 12b */
};

#define CDROM_MAX_TOC 804
#define CDROM_MAX_MODE_BUF 20

struct DCB_cdrom {
  DCB DCB_filler_2;					/* 000 */
  unsigned long DCB_cdrom_Partition_Start;		/* 12b */
  unsigned long DCB_cdrom_Partition_End;		/* 12f */
  unsigned char DCB_cd_ls_ft;				/* 133 */
  unsigned long DCB_TOC[CDROM_MAX_TOC / 4 + 1];		/* 134 */
  unsigned long DCB_cd_mode_sense_buf[CDROM_MAX_MODE_BUF / 4 + 1]; /* 45c */
  unsigned char DCB_cd_first_session;			/* 474 */
  unsigned char DCB_cd_last_session;			/* 475 */
  unsigned long DCB_play_resume_start;			/* 476 */
  unsigned long DCB_play_resume_stop;			/* 47a */
  unsigned long DCB_play_status;			/* 47e */
  unsigned long DCB_cd_device_flags;			/* 482 */
  unsigned char DCB_cd_fs_lt;				/* 486 */
  unsigned char DCB_cd_bobbit_pt;			/* 487 */
  unsigned long DCB_cd_fs_lo;				/* 488 */
  unsigned long DCB_cd_last_session_start;		/* 48c */
  unsigned long DCB_cd_current_block_size;		/* 490 */
  unsigned char DCB_cd_vol_map[8];			/* 494 */
  unsigned long DCB_cd_current_command;			/* 49c */
  unsigned long DCB_cd_queue_head;			/* 4a0 */
  unsigned long DCB_cd_reserved;			/* 4a4 */
							/* 4a8 */
};

struct type_sdeffsd_req_usage {
  unsigned short _IOR_ioctl_drive;
  unsigned short _IOR_ioctl_function;
  unsigned int _IOR_ioctl_control_param;
  unsigned int _IOR_ioctl_buffer_ptr;
  unsigned int _IOR_ioctl_client_params;
  unsigned int _IOR_ioctl_return;
};

union urequestor_usage {
   unsigned int _IOR_requestor_usage[5];
   struct type_sdeffsd_req_usage sdeffsd_req_usage;
};

struct IOR {
  unsigned int IOR_next;			/* 00 */
  unsigned short IOR_func;			/* 04 */
  unsigned short IOR_status;			/* 06 */
  unsigned int IOR_flags;			/* 08 */
  void (*IOR_callback)(IOP*);			/* 0c */
  unsigned int IOR_start_addr[2];		/* 10 */
  unsigned int IOR_xfer_count;			/* 14 */
  unsigned int IOR_buffer_ptr;			/* 18 */
  unsigned int IOR_private_client;		/* 1c */
  unsigned int IOR_private_IOS;			/* 20 */
  unsigned int IOR_private_port;		/* 24 */
  urequestor_usage _ureq;			/* 28 */
  unsigned int IOR_req_req_handle;		/* 3c */
  unsigned int IOR_req_vol_handle;		/* 40 */
  unsigned int IOR_sgd_lin_phys;		/* 44 */
  unsigned char IOR_num_sgds;			/* 48 */
  unsigned char IOR_vol_designtr;		/* 49 */
  unsigned short IOR_ios_private_1;		/* 4a */
  unsigned int IOR_reserved_2[2];		/* 4c */
						/* 54 */
};

struct IOP_callback_entry {
  void (*IOP_CB_address)(IOP*);
  unsigned long IOP_CB_ref_data;
};

#define IOP_CALLBACK_TABLE_DEPTH 6

struct IOP {
  void *IOP_physical;				/* 00 */
  DCB_COMMON* IOP_physical_dcb;			/* 04 */
  DCB_COMMON* IOP_original_dcb;			/* 08 */
  unsigned short IOP_timer;			/* 0c */
  unsigned short IOP_timer_orig;		/* 0e */
  DCB_cd_entry *IOP_calldown_ptr;		/* 10 */
  IOP_callback_entry *IOP_callback_ptr;		/* 14 */
  unsigned int IOP_voltrk_private;		/* 18 */
  unsigned int IOP_Thread_Handle;		/* 1c */
  unsigned int IOP_srb;				/* 20 */
  unsigned int IOP_reserved[2];			/* 24 */
  IOP_callback_entry IOP_callback_table[IOP_CALLBACK_TABLE_DEPTH]; /* 2c */
  char IOP_format_head;				/* 5c */
  char IOP_format_xfer_rate;			/* 5d */
  unsigned short IOP_format_track;		/* 5e */
  unsigned int IOP_format_num_sectors;		/* 60 */
  IOR IOP_ior;					/* 64 */
						/* b8 */
};

struct ISP {
  unsigned short ISP_func;
  unsigned short ISP_result;
};

struct ISP_calldown_insert {
  ISP ISP_i_cd_hdr;
  DCB_COMMON* ISP_i_cd_dcb;
  void *ISP_i_cd_req;
  void *ISP_i_cd_ddb;
  unsigned short ISP_i_cd_expan_len;
  unsigned long ISP_i_cd_flags;
  unsigned char ISP_i_cd_lgn;
  unsigned char ISP_pad4[1];
};

struct ISP_IOP_create {
  ISP ISP_i_c_hdr;			/* 00 */
  unsigned short ISP_IOP_size;		/* 04 */
  unsigned long ISP_delta_to_ior;	/* 06 */
  unsigned long ISP_IOP_ptr;		/* 0a */
  unsigned char ISP_i_c_flags;		/* 0e */
  unsigned char ISP_pad2[1];		/* 0f */
					/* 10 */
};

struct ISP_mem_alloc {
  ISP ISP_mem_a_hdr;
  unsigned short ISP_mem_size;
  unsigned long ISP_mem_ptr;
  unsigned short ISP_mem_type;
  unsigned char ISP_mem_flags;
  unsigned char ISP_pad3[3];
};

struct ISP_mem_dealloc {
  ISP ISP_mem_da_hdr;
  unsigned long ISP_mem_ptr_da;
};

struct ISP_pick_drive_letter {
  ISP ISP_p_d_l_hdr;
  void *ISP_p_d_l_pdcb;
  unsigned char ISP_p_d_l_letter[2];
  unsigned char ISP_p_d_l_flags;
  unsigned char ISP_p_d_l_pad[1];
};

#define DRP_IFS             0x00000001 /* reserved for ifs manager         */
#define DRP_RESRVD1         0x00000002 /* reserved - do not use            */
#define DRP_FSD             0x00000004 /* Installable File system layer    */
#define DRP_FSD_EXT_1       0x00000008 /* FSD extension, e.g., DBLSPACE    */
#define DRP_FSD_EXT_2       0x00000010 /* FSD extension, e.g., encryption  */
#define DRP_VOLTRK          0x00000020 /* post-volume tracking value added driver */
#define DRP_CLASS_DRV       0x00000040 /* class driver                     */
#define DRP_TSD             0x00000080 /* type specific driver             */
#define DRP_VSD_1           0x00000100 /* vendor enhancement layer 1 */
#define DRP_VSD_2           0x00000200 /* vendor enhancement layer 2 */
#define DRP_VSD_3           0x00000400 /* vendor enhancement layer 3 */
#define DRP_SCSI_LAYER      0x00000800 /* SCSI'izer                        */
#define DRP_VSD_4           0x00001000 /* vendor enhancement layer 4 */
#define DRP_VSD_5           0x00002000 /* vendor enhancement layer 5 */
#define DRP_VSD_6           0x00004000 /* vendor enhancement layer 6 */
#define DRP_VSD_7           0x00008000 /* vendor enhancement layer 7 */
#define DRP_VSD_8           0x00010000 /* vendor enhancement layer 8 */
#define DRP_VSD_9           0x00020000 /* vendor enhancement layer 9 */
#define DRP_RESRVD18        0x00040000 /* reserved do not use              */
#define DRP_MISC_PD         0x00080000 /* other port drivers               */
#define DRP_NT_MPD          0x00100000 /* NT style mini-port drivers       */
#define DRP_NT_PD           0x00200000 /* NT style port (hw independ) drvr */
#define DRP_ESDI_PD         0x00400000 /* ESDI port driver                 */
#define DRP_ESDIEMUL_PD     0x00800000 /* port drivers for esdi emulators  */
#define DRP_RESRVD23        0x01000000 /* reserved do not use              */
#define DRP_ABIOS_PD        0x02000000 /* ABIOS port driver                */
#define DRP_ABIOS_PREMPT_PD 0x04000000 /* ABIOS pre-empting port drivers   */
#define DRP_NEC_FLOPPY      0x08000000 /* NEC floppy driver layer          */
#define DRP_RESRVD28        0x10000000 /* reserved do not use              */
#define DRP_SOC_SER_DRV     0x20000000 /* socket service drivers           */
#define DRP_SOC_DRV         0x40000000 /* socket drivers                   */
#define DRP_IOS_REG         0x80000000 /* reserved for ios registry        */

struct SCSI_REQUEST_BLOCK {
   unsigned short Length;		/* 00 */
   unsigned char Function;		/* 02 */
   unsigned char SrbStatus;		/* 03 */
   unsigned char ScsiStatus;		/* 04 */
   unsigned char PathId;		/* 05 */
   unsigned char TargetId;		/* 06 */
   unsigned char Lun;			/* 07 */
   unsigned char QueueTag;		/* 08 */
   unsigned char QueueAction;		/* 09 */
   unsigned char CdbLength;		/* 0a */
   unsigned char SenseInfoBufferLength;	/* 0b */
   unsigned long SrbFlags;		/* 0c */
   unsigned long DataTransferLength;	/* 10 */
   unsigned long TimeOutValue;		/* 14 */
   void *DataBuffer;			/* 18 */
   void *SenseInfoBuffer;		/* 1c */
   struct SCSI_REQUEST_BLOCK *NextSrb;	/* 20 */
   void *OriginalRequest;		/* 24 */
   void *SrbExtension;			/* 28 */
   unsigned long QueueSortKey;		/* 2c */
   unsigned char Cdb[16];		/* 30 */
					/* 40 */
};

typedef struct AEPHDR {
  unsigned short AEP_func;	/* 00 */
  unsigned short AEP_result;	/* 02 */
  unsigned long AEP_ddb;	/* 04 driver data block pointer */
  unsigned char AEP_lgn;	/* 08 current load group number */
  unsigned char AEP_align[3];	/* 09 */
  				/* 0c */
} AEP;

#define AEP_SUCCESS 0
#define AEP_FAILURE -1

typedef struct AEP_bi_init {
  struct AEPHDR	AEP_bi_i_hdr;
  unsigned long	AEP_bi_reference_data;
  unsigned char AEP_bi_flags;
  char AEP_bi_i_max_target;
  char AEP_bi_i_max_lun;
  DCB_COMMON	*AEP_bi_i_dcb;		/* init dcb for port drivers */
  void *AEP_bi_i_hdev_node;	/* handle to devnode for this adapter */
  void *AEP_bi_i_regkey;	/* registry key for this adapter */
  unsigned char	AEP_bi_i_align[1];
} AEP_bi_init;

#define AEP_BI_FL_SCSI_SCAN_DOWN 0x01
#define AEP_BI_FL_SEND_COMMAND_AGAIN 0x02

struct AEP_boot_done {
  struct AEPHDR	AEP_b_d_hdr;
};

struct AEP_dcb_config {
  struct AEPHDR AEP_d_c_hdr;
  DCB_COMMON *AEP_d_c_dcb;	/* 32-bit ptr to DCB */
};

struct VRP {	// Volume Request Parameters
  unsigned int VRP_demand_flags;	/* 00 */
  unsigned int VRP_event_flags;		/* 04 */
  unsigned short VRP_max_sgd;		/* 08 */
  unsigned short VRP_max_req_size;	/* 0a */
  unsigned int VRP_delta_to_ior;	/* 0c */
  unsigned int VRP_block_size;		/* 10 */
  unsigned int VRP_fsd_hvol;		/* 14 */
  unsigned int VRP_device_handle;	/* 18 */
  unsigned int VRP_partition_offset;	/* 1c */
  unsigned int VRP_next_vrp;		/* 20 */
  unsigned int VRP_logical_handle;	/* 24 */
  unsigned int VRP_reserved;		/* 28 */
  					/* 2c */
};

#define NUM_VOLFUNC 15

struct volfunc {
 short vfn_version;
 char vfn_revision;
 char vfn_size;
 void *vfn_func[NUM_VOLFUNC];
};

#define NUM_HNDLMISC 8

struct hndlmisc {
  short hm_version;
  char hm_revision;
  char hm_size;
  void *hm_func[NUM_HNDLMISC];
};

struct hndlfunc {
  void *hf_read;
  void *hf_write;
  hndlmisc *hf_misc;
};

struct dos_time {
  unsigned short  dt_time;
  unsigned short  dt_date;
};

union aux_t {
  void *aux_buf;
  unsigned long aux_ul;
  dos_time aux_dt;
  volfunc *aux_vf;
  hndlfunc *aux_hf;
  void *aux_ptr;
  unsigned short *aux_str;
  void *aux_pp;
  unsigned int aux_ui;
};

struct PathElement {
  unsigned short pe_length;
  unsigned short pe_unichars[1];
};

struct ParsedPath {
  unsigned short pp_totalLength;
  unsigned short pp_prefixLength;
  struct PathElement pp_elements[1];
};

struct ioreq {
  unsigned int ir_length;		/* 00 */
  unsigned char ir_flags;		/* 04 */
  unsigned char ir_user;		/* 05 */
  unsigned short ir_sfn;		/* 06 */
  unsigned int ir_pid;			/* 08 */
  ParsedPath *ir_ppath;			/* 0c */
  aux_t ir_aux1;			/* 10 */
  void *ir_data;			/* 14 */
  unsigned short ir_options;		/* 18 */
  short ir_error;			/* 1a */
  void *ir_rh;				/* 1c */
  void *ir_fh;				/* 20 */
  unsigned long ir_pos;			/* 24 */
  aux_t ir_aux2;			/* 28 */
  aux_t ir_aux3;			/* 2c */
  void *ir_pev;				/* 30 */
  int ir_fsd[16];			/* 34 */
					/* 74 */
};

#define ir_volh		ir_aux1.aux_ul
#define ir_vfunc	ir_aux1.aux_vf
#define ir_hfunc	ir_aux1.aux_hf
#define ir_mntdrv	ir_aux2.aux_ul
#define ir_numfree	ir_aux2.aux_ul
#define ir_uFName	ir_aux2.aux_str
#define ir_upath	ir_aux3.aux_str
#define ir_size		ir_pos
#define ir_attr		ir_length
#define ir_sectors	ir_options

struct win_FILETIME {
        unsigned long   dwLowDateTime;
        unsigned long   dwHighDateTime;
};

#define win_MAX_PATH 260

struct win32_find_data {
  unsigned long dwFileAttributes;
  struct win_FILETIME ftCreationTime;
  struct win_FILETIME ftLastAccessTime;
  struct win_FILETIME ftLastWriteTime;
  unsigned long nFileSizeHigh;
  unsigned long nFileSizeLow;
  unsigned long dwReserved0;
  unsigned long dwReserved1;
  unsigned short cFileName[win_MAX_PATH];
  unsigned short cAlternateFileName[14];
};
